const fs = require('fs-extra')
const { rename: renameAsync } = require('fs').promises
const path = require('path')
const juisy = require('@hperchec/juisy')
// const vuepressJsdocStatisticTypes = Object.values(require('vuepress-jsdoc/dist/constants').StatisticType) // EMPTY, ERROR, INCLUDE, EXCLUDE
const vuepressJsdocStatisticTypes = [ 'EMPTY', 'ERROR', 'INCLUDE', 'EXCLUDE' ]
// utils
const {
  rootDir,
  $style,
  wait,
  getFileUrls,
  getFiles,
  error,
  run,
  log,
  step,
  substep,
  stripAnsi
} = juisy.utils
// buildSidebar tool
const buildSidebar = require('./build-sidebar')

// Default config
const defaultConfig = {
  title: 'API',
  sourceDir: './src',
  distDir: './.docs',
  outputDir: 'output',
  exclude: '**/*/*.test.js',
  partials: [],
  reportFile: './.docs/api.report.txt',
  sourceFiles: [],
  jsdoc2md: {},
  docgen: {},
  jsdoc: {},
  vuepress: {
    basePath: '',
    targetPath: '/guide/api'
  }
}

/**
 * Generate doc function
 * @param {object} [options = {}] - The options object
 * @param {boolean} [devMode = false] - Development mode
 * @returns {void}
 */
module.exports = async function generateAPIDoc (options = {}, devMode = false) {
  // Process options
  options = Object.assign(defaultConfig, options)
  const sourceDirPath = path.resolve(rootDir, options.sourceDir)
  const outputFullPath = path.join(rootDir, options.distDir, options.outputDir)
  // Drop old report file
  const reportFilePath = path.resolve(rootDir, options.reportFile)

  // vuepress-jsdoc command args
  const cmdArgs = [
    'vuepress-jsdoc',
    '--source', options.sourceDir,
    '--dist', options.distDir,
    '--folder', options.outputDir,
    '--title', options.title,
    '--exclude', options.exclude.join(','),
    ...(options.docgen.configPath ? [ '--docgen-configPath', options.docgen.configPath ] : []),
    ...(options.jsdoc.configPath ? [ '--jsDoc-configPath', options.jsdoc.configPath ] : []),
    ...(options.jsdoc2md.partials.reduce((partialOptions, partial) => {
      partialOptions.push('--j2md-partial')
      partialOptions.push(partial)
      return partialOptions
    }, [])),
    ...(options.jsdoc2md.helpers.reduce((helperOptions, helper) => {
      helperOptions.push('--j2md-helper')
      helperOptions.push(helper)
      return helperOptions
    }, [])),
    ...(devMode ? [ '--watch' ] : [])
  ]

  let genResult

  /**
   * Generate doc
   */
  step('Generate API doc')

  // If devMode is enabled, just run vuepress-jsdoc command with --watch option
  if (devMode) {
    await run('npx', cmdArgs, { stdio: 'inherit' })
  } else {
    // Display loading during generation
    await wait('Generating', async () => {
      try {
        genResult = await run('npx', cmdArgs, { stdio: 'pipe' })
      } catch (e) {
        error('Unable to generate documentation', e)
      }
    })

    // Parse output
    const stats = {}
    let total = 0
    for (const type of vuepressJsdocStatisticTypes) {
      const matches = [ ...genResult.stdout.matchAll(new RegExp(`${type}\\s+(\\S*)`, 'g')) ]
      stats[type] = {
        length: matches.length,
        files: matches.map(match => match[1].replace(/\\/g, '/') /* windows compat */)
      }
      total += matches.length
    }

    // INCLUDE files
    let statsToStr = `INCLUDE: ${stats.INCLUDE.length} file(s):\n`
    substep($style.green(`Include: ${stats.INCLUDE.length} file(s)`))
    for (const file of stats.INCLUDE.files) statsToStr += $style.green(`\n  - ${file}`)
    // EMPTY files
    if (stats.EMPTY.length > 0) {
      statsToStr += `\n\nEMPTY: ${stats.EMPTY.length} file(s):\n`
      substep($style.yellow(`Empty: ${stats.EMPTY.length} file(s)`))
      for (const file of stats.EMPTY.files) statsToStr += $style.yellow(`\n  - ${file}`)
    }
    // EXCLUDE files
    if (stats.EXCLUDE.length > 0) {
      statsToStr += `\n\nEXCLUDE: ${stats.EXCLUDE.length} file(s):\n`
      substep(`Exclude: ${stats.EXCLUDE.length} file(s)`)
      for (const file of stats.EXCLUDE.files) statsToStr += `\n  - ${file}`
    }
    // ERROR files
    if (stats.ERROR.length > 0) {
      statsToStr += `\n\nERROR: ${stats.ERROR.length} file(s):\n`
      substep($style.red(`Error: ${stats.ERROR.length} file(s)`))
      for (const file of stats.ERROR.files) statsToStr += $style.red(`\n  - ${file}`)
    }
    // Total
    statsToStr += `\n\nTOTAL: ${total} file(s)`
    substep(`${$style.bold('Total:')} ${total} file(s)`)

    // Write output to report file
    const header = `# Generated: [${new Date()}]`
    const startTag = '# [vuepress-jsdoc output]'
    const endTag = '# [vuepress-jsdoc end]'
    fs.writeFileSync(
      reportFilePath,
      stripAnsi(`${header}\n\n${startTag}\n${genResult.stdout}\n${endTag}\n\n${statsToStr}\n`),
      { encoding: 'utf8' }
    )
    substep($style.green('✔ Documentation successfuly generated by vuepress-jsdoc'), { last: true })
    log() // Blank line

    /**
     * Build sidebar
     */
    step('Build sidebar')
    const generatedSidebar = require(`${outputFullPath}/config.js`).sidebarTree()[`/${options.outputDir}/`]
    const sidebar = buildSidebar(generatedSidebar, outputFullPath, (options.vuepress.targetPath + '/'))
    // Write file 'docs/output/sidebar.js'
    const fileContent = 'module.exports = ' + JSON.stringify(sidebar, true, 4)
    const sidebarPath = path.resolve(outputFullPath, 'sidebar.js')
    fs.writeFileSync(sidebarPath, fileContent)
    // Append to report file
    fs.appendFileSync(reportFilePath, `\nBUILT SIDEBAR  ${sidebarPath.replace(rootDir, '').substring(1)}\n\n`, { encoding: 'utf8' })
    substep($style.green('✔ Sidebar successfuly created'), { last: true })
    log() // Blank line

    // Remove the generated README.md file at the root
    const readmePath = path.resolve(outputFullPath, 'README.md')
    if (fs.existsSync(readmePath)) {
      step('Removing auto-generated README file')
      // Unlink
      fs.unlinkSync(readmePath)
      // Append to report file
      fs.appendFileSync(reportFilePath, `REMOVED  ${readmePath.replace(rootDir, '').substring(1)}\n\n`, { encoding: 'utf8' })
      substep($style.green('✔ File successfuly deleted'), { last: true })
      log() // Blank line
    }

    // Rename all '__index__.md' file to 'README.md'
    step('Renaming all "index" files')
    await wait('Renaming', async () => {
      for await (const f of getFiles(`${outputFullPath}`)) {
        // Get filename
        const filename = path.basename(f)
        let finalName
        // Rename if '__index__.md'
        if (filename === '__index__.md') {
          finalName = f.replace('__index__.md', 'README.md')
          await renameAsync(f, finalName)
          // Append to report file
          fs.appendFileSync(reportFilePath, `RENAMED  ${f.replace(rootDir, '').substring(1)} → ${finalName.replace(rootDir, '').substring(1)}\n`, { encoding: 'utf8' })
        } else if (/^(index\.md)$/i.test(filename)) {
          finalName = f.replace(/(index\.md)$/i, '_$&')
          await renameAsync(f, finalName)
          // Append to report file
          fs.appendFileSync(reportFilePath, `RENAMED  ${f.replace(rootDir, '').substring(1)} → ${finalName.replace(rootDir, '').substring(1)}\n`, { encoding: 'utf8' })
        }
      }
    })
    substep($style.green('✔ Success'), { last: true })
    log() // Blank line

    // Copy source files
    step('Copy source files')
    await wait('Copying', async () => {
      for (const fileUrl of getFileUrls(options.sourceFiles, { cwd: sourceDirPath })) {
        const sourcePath = path.resolve(sourceDirPath, fileUrl)
        const extName = path.extname(fileUrl)
        const fileName = path.basename(fileUrl, extName)
        const targetPath = path.resolve(outputFullPath, path.join(path.dirname(fileUrl), `${fileName}.source${extName}`))
        // console.log('file: ', targetPath)
        fs.outputFileSync(targetPath, fs.readFileSync(sourcePath, { encoding: 'utf-8' }))
      }
    })
    substep($style.green('✔ Success'), { last: true })
    log() // Blank line

    log($style.cyan(`See ${options.reportFile} file for report`))
    log() // Blank line
  }
}
